<?php
################################################################################
# @Name : ./plugins/mailstoservice/admin/parameters.php
# @Description : admin parameters for mailstoservice plugins
# @Call : /admin/parameters/plugins.php
# @Author : Flox
# @Create : 28/04/2015
# @Update : 24/08/2023
# @Version : 3.2.38
################################################################################

if ($plugin['enable'] && $rright['admin']) {

    //initialize variables 
    if (!isset($_POST['mailstoservice_subcat']))
        $_POST['mailstoservice_subcat'] = '';
    if (!isset($_POST['mailstoservice_category']))
        $_POST['mailstoservice_category'] = '';
    if (!isset($_POST['mailstoservice_service_id']))
        $_POST['mailstoservice_service_id'] = '';
    if (!isset($_POST['mailstoservice_subject_tag']))
        $_POST['mailstoservice_subject_tag'] = '';

    if (!isset($_GET['deletemailstoservice']))
        $_GET['deletemailstoservice'] = '';

    //secure inputs
    $_POST['mailstoservice_subcat'] = htmlspecialchars($_POST['mailstoservice_subcat'], ENT_QUOTES, 'UTF-8');
    $_POST['mailstoservice_category'] = htmlspecialchars($_POST['mailstoservice_category'], ENT_QUOTES, 'UTF-8');
    $_POST['mailstoservice_service_id'] = htmlspecialchars($_POST['mailstoservice_service_id'], ENT_QUOTES, 'UTF-8');
    $_POST['mailstoservice_subject_tag'] = htmlspecialchars($_POST['mailstoservice_subject_tag'], ENT_QUOTES, 'UTF-8');

    $_GET['deletemailstoservice'] = htmlspecialchars($_GET['deletemailstoservice'], ENT_QUOTES, 'UTF-8');

    //add new association
    if ($_POST['mailstoservice_subject_tag']) {
        $qry = $db->prepare("INSERT INTO `tparameters_imap_mailstoservice` (
                `subject_tag`,
                `service_id`,
                `category`,
                `subcat`
                ) VALUES (
                    :subject_tag,
                    :service_id,
                    :category,
                    :subcat
                    )");
        $qry->execute(
            array(
                'subject_tag' => $_POST['mailstoservice_subject_tag'],
                'service_id' => $_POST['mailstoservice_service_id'],
                'category' => $_POST['mailstoservice_category'],
                'subcat' => $_POST['mailstoservice_subcat']
            )
        );
    }
    $qry->closeCursor();

    //db delete
    if ($_GET['deletemailstoservice']) //remove cat from mailstoservice list
    {
        $qry = $db->prepare("DELETE FROM tparameters_imap_mailstoservice WHERE id=:id");
        $qry->execute(array('id' => $_GET['deletemailstoservice']));
    }

    echo '<label class="lbl" for="mailstoservice_list">' . T_('Liste des affectations') . ' :</label>';
    echo '<ul id="mailstoservice_list">';
    //display all existing association
    $qry = $db->prepare("SELECT * FROM `tparameters_imap_mailstoservice` ORDER BY `service_id`, `subject_tag`");
    $qry->execute();
    $empty = true;
	$change = 0;
    while ($row = $qry->fetch()) {
        $empty = false;
        //get service name do display
        $qry2 = $db->prepare("SELECT `name` FROM `tservices` WHERE `id`=:id");
        $qry2->execute(array('id' => $row['service_id']));
        $row2 = $qry2->fetch();
        $qry2->closeCursor();

        //get category name do display
        $qry3 = $db->prepare("SELECT `name` FROM `tcategory` WHERE `id`=:id");
        $qry3->execute(array('id' => $row['category']));
        $row3 = $qry3->fetch();
        $qry3->closeCursor();

        //get subcat name do display
        $qry4 = $db->prepare("SELECT `name` FROM `tsubcat` WHERE `id`=:id");
        $qry4->execute(array('id' => $row['subcat']));
        $row4 = $qry4->fetch();
        $qry4->closeCursor();

        if (empty($row2['name'])) {
            $row2 = array();
            $row2['name'] = '';
        } else {
            $row2['name'] = ' > <small><i>Service</i></small> : ' . $row2['name'];
        }
        if (empty($row3['name'])) {
            $row3 = array();
            $row3['name'] = '';
        } else {
            $row3['name'] = ' > <small><i>Catégorie</i></small> : ' . $row3['name'];
        }
        if (empty($row4['name'])) {
            $row4 = array();
            $row4['name'] = '';
        } else {
            $row4['name'] = ' | ' . $row4['name'].' ';
        }
        if (empty($row['subject_tag'])) {
            $row = array();
            $row['subject_tag'] = '';
        }
		if($change!=$row['service_id']){
			echo '<br/>';
			$change = $row['service_id'];
		}
        echo '<li><b>' . $row['subject_tag'] . '</b>' . $row2['name'] . $row3['name'] . $row4['name'];
        echo '<a onClick="javascript: return confirm(\'' . T_('Etes-vous sur de vouloir supprimer cette affectation de mail ?') . '\');" href="./index.php?page=admin&subpage=parameters&tab=plugin&deletemailstoservice=' . $row['id'] . '"><i title="' . T_("Supprimer cette affectation") . '" class="fa fa-trash text-danger bigger-130"><!----></i></a>';
        echo '</li>';
    }
    if($empty){
        echo 'Aucune affectation de mail a été programmée';
    }

    $qry->closeCursor();
    echo "</ul>";
    echo '<label class="lbl" for="mailstoservice_list">' . T_('Créer une nouvelle affectation') . ' :</label><br/>';
    //inputs for new association
    echo '&nbsp;&nbsp;&nbsp;
                                                <span id="mailstoservice_subject_tag">
                                                    <input style="width:auto" class="form-control  d-inline-block" name="mailstoservice_subject_tag" type="text" value="" size="20" placeholder="'.T_('Tag, exemple : [TAG]').'" />&nbsp
                                                </span>
                                                <label class="lbl" for="mailstoservice_service_id">' . T_('Service') . ' :</label> 
                                                <select style="width:auto" class="form-control  d-inline-block" id="mailstoservice_service_id" name="mailstoservice_service_id" >
                                                    ';
    $qry = $db->prepare("SELECT `id`,`name` FROM `tservices` WHERE `disable`='0'");
    $qry->execute();
    while ($row = $qry->fetch()) {
        echo '<option value="' . $row['id'] . '">' . $row['name'] . '</option>';
    }
    $qry->closeCursor();
    echo '
                                                </select>
                                                <label class="lbl" for="mailstoservice_category">' . T_('Catégorie') . ' :</label> 
                                                <select style="width:auto" class="form-control  d-inline-block" id="mailstoservice_category" name="mailstoservice_category" >
                                                    ';
    $qry = $db->prepare("SELECT `id`,`name`,`service` FROM `tcategory` ORDER BY service, name");
    $qry->execute();
    while ($row = $qry->fetch()) {
        echo '<option service="' . $row['service'] . '" value="' . $row['id'] . '">' . $row['name'] . '</option>';
    }
    $qry->closeCursor();
    echo '
                                                </select>
                                                <label class="lbl" for="mailstoservice_subcat">|</label> 
                                                <select style="width:auto" class="form-control  d-inline-block" id="mailstoservice_subcat" name="mailstoservice_subcat" >
                                                    ';
    $qry = $db->prepare("SELECT `id`,`name`,`cat` FROM `tsubcat` ORDER BY cat, name");
    $qry->execute();
    while ($row = $qry->fetch()) {
        $selected = (!$_POST['mailstoservice_subject_tag'] && $row['id']==0) ?' selected':'';
        echo '<option category="' . $row['cat'] . '" value="' . $row['id'] . '"'.$selected.'>' . $row['name'] . '</option>';
    }
    $qry->closeCursor();
    echo '
                                                </select>
                                                ';

}
?>
	<script>
		var elt_ser = document.querySelector('select#mailstoservice_service_id');
		var elt_cat = document.querySelector('select#mailstoservice_category');
		
		elt_cat.addEventListener('change', function () {
			const elt_sub1 = document.querySelector('select#mailstoservice_subcat');
			let childrens1 = elt_sub1.childNodes;
			for (const child of elt_sub1.options) {
				category = child.getAttribute("category");
				select1 = this.value;
				if(category != 0 && category != select1 && select1 !=0){
					child.style.display = 'none';
				} else {
					child.style.display = 'block';
				}
			}
		});
		elt_ser.addEventListener('change', function () {
			const elt_sub2 = document.querySelector('select#mailstoservice_category');
			let childrens2 = elt_sub2.childNodes;
			for (const child of elt_sub2.options) {
				service = child.getAttribute("service");
				select2 = this.value;
				if(service != 0 && service != select2 && select2 !=0){
					child.style.display = 'none';
				} else {
					child.style.display = 'block';
				}
			}
		});
	</script>